unit wsaerror;

interface

function WSAErrMsg(n : word) : pchar;

implementation

uses
 WinSock, SysUtils;

var
 RetMsg : pchar;

function WSAErrMsg;
var
 s : string[100];
begin
str(n-WSABASEERR,s);
s:='WINSOCK error #'+s+': ';
case n of
  WSAEINTR:
    s:=s+'Unknown error';
  WSAEBADF:
    s:=s+'Unknown error';
  WSAEACCES:
    s:=s+'Unknown error';
  WSAEFAULT:
    s:=s+'Unknown error';
  WSAEINVAL:
    s:=s+'Unknown error';
  WSAEMFILE:
    s:=s+'Unknown error';
  WSAEWOULDBLOCK:
    s:=s+'Connection would be block.';
  WSAEINPROGRESS:
    s:=s+'Connection in progress.';
  WSAEALREADY:
    s:=s+'Unknown error';
  WSAENOTSOCK:
    s:=s+'Handler not a socket.';
  WSAEDESTADDRREQ:
    s:=s+'Destination address request error.';
  WSAEMSGSIZE:
    s:=s+'MSG size error.';
  WSAEPROTOTYPE:
    s:=s+'Error protocol type.';
  WSAENOPROTOOPT:
    s:=s+'No protocol options.';
  WSAEPROTONOSUPPORT:
    s:=s+'Protocol not supported.';
  WSAESOCKTNOSUPPORT:
    s:=s+'Socket type not supported.';
  WSAEOPNOTSUPP:
    s:=s+'Operation not supported.';
  WSAEPFNOSUPPORT:
    s:=s+'Protocol not supported.';
  WSAEAFNOSUPPORT:
    s:=s+'Adress not supported.';
  WSAEADDRINUSE:
    s:=s+'Addres already in use.';
  WSAEADDRNOTAVAIL:
    s:=s+'Address not available.';
  WSAENETDOWN:
    s:=s+'Network is down.';
  WSAENETUNREACH:
    s:=s+'Network unreachable.';
  WSAENETRESET:
    s:=s+'Network reset.';
  WSAECONNABORTED:
    s:=s+'Connection aborted.';
  WSAECONNRESET:
    s:=s+'Reset connection.';
  WSAENOBUFS:
    s:=s+'No more buffers.';
  WSAEISCONN:
    s:=s+'Already connected.';
  WSAENOTCONN:
    s:=s+'Not connected.';
  WSAESHUTDOWN:
    s:=s+'Shutdown.';
  WSAETOOMANYREFS:
    s:=s+'Too many references.';
  WSAETIMEDOUT:
    s:=s+'Timeout.';
  WSAECONNREFUSED:
    s:=s+'Connection refused.';
  WSAELOOP:
    s:=s+'Loop (recursive coonection).';
  WSAENAMETOOLONG:
    s:=s+'Name too long.';
  WSAEHOSTDOWN:
    s:=s+'Host is down.';
  WSAEHOSTUNREACH:
    s:=s+'Host unreachable.';
  WSAENOTEMPTY:
    s:=s+'Unknown error';
  WSAEPROCLIM:
    s:=s+'Unknown error';
  WSAEUSERS:
    s:=s+'Unknown error';
  WSAEDQUOT:
    s:=s+'Unknown error';
  WSAESTALE:
    s:=s+'Unknown error';
  WSAEREMOTE:
    s:=s+'Remote error';
  WSASYSNOTREADY:
    s:=s+'Not ready.';
  WSAVERNOTSUPPORTED:
    s:=s+'Not supported version WINSOCK.';
  WSANOTINITIALISED:
    s:=s+'Windows socket library was not initialised.';
  else
    s:=s+'Unknown error.';
  end;
strpcopy(RetMsg,s);
WSAErrMsg:=RetMsg;
end;

begin
getmem(RetMsg,1024);
end.