unit MainS;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, SvcMgr, Dialogs,
  Server;

type
  TNTPopService = class(TService)
    procedure ServiceStart(Sender: TService; var Started: Boolean);
    procedure ServiceStop(Sender: TService; var Stopped: Boolean);
  private
    Server : TListener;
  public
    function GetServiceController: TServiceController; override;
    { Public declarations }
  end;

var
  NTPopService: TNTPopService;

implementation

{$R *.DFM}

uses
 Lsts, Config;

procedure ServiceController(CtrlCode: DWord); stdcall;
begin
  NTPopService.Controller(CtrlCode);
end;

function TNTPopService.GetServiceController: TServiceController;
begin
  Result := ServiceController;
end;

procedure TNTPopService.ServiceStart(Sender: TService; var Started: Boolean);
begin
HostList:=THostList.Create;
UserList:=TUserList.Create;
DomainList:=TDomainList.Create;
LoadConfiguration;
Server:=TListener.Create(self);
if not Server.Run then
  begin
  NTPopService.ServiceThread.Terminate;
  end;
end;

procedure TNTPopService.ServiceStop(Sender: TService;
  var Stopped: Boolean);
begin
Server.Terminate;
end;

end.
